echo complete > g:\build\stat\begin.tmp
REM ============================================================
REM Get the source from SVN if we don't have it already

IF EXIST g:\build\stat\svnexprt.tmp goto SVN01

f:\subversion\bin\svn.exe export https://fbc.svn.sourceforge.net/svnroot/fbc/branches/fbc-0_20-branch/FreeBASIC g:\FreeBASIC
if errorlevel 1 goto ERROR

echo complete > g:\build\stat\svnexprt.tmp

:SVN01

REM ============================================================
REM Copy extra files

copy f:\freebasic\lib\dos\libcunit.a g:\freebasic\lib\dos\libcunit.a

REM ============================================================
REM Remake the input files needed configure

IF EXIST g:\build\stat\autoconf.tmp goto ACNF02

call setpath.bat DJS

g:
cd \FreeBASIC\src

cd rtlib
sh autoconf
if errorlevel 1 goto ERROR
deltree /y autom4te.cache
cd ..

cd gfxlib2
sh autoconf
if errorlevel 1 goto ERROR
deltree /y autom4te.cache
cd ..

cd compiler
sh autoconf
if errorlevel 1 goto ERROR
deltree /y autom4te.cache
cd ..

cd ..\..

echo complete > g:\build\stat\autoconf.tmp

:ACNF02

REM ============================================================
REM configure rtlib, gfxlib2, and compiler for windows

IF EXIST g:\build\stat\conf_win.tmp goto WCNF03

call setpath.bat FB181

g:
cd \FreeBASIC\src

cd rtlib\obj\win32
sh ../../configure CFLAGS=-O2
if errorlevel 1 goto ERROR
cd ..\..\..

cd gfxlib2\obj\win32
sh ../../configure CFLAGS=-O2
if errorlevel 1 goto ERROR
cd ..\..\..

cd compiler\obj\win32
sh ../../configure --enable-standalone --enable-crosscomp-dos --enable-crosscomp-cygwin
if errorlevel 1 goto ERROR
cd ..\..\..

echo complete > g:\build\stat\conf_win.tmp

:WCNF03

IF EXIST g:\build\stat\strp_win.tmp goto WSTR04

call setpath.bat MINGW

g:
cd \FreeBASIC\src

copy compiler\obj\win32\config.status compiler\obj\win32\config.status.bak
sed 's/\/g\/FreeBASIC\/src\/config\/missing //g' < compiler\obj\win32\config.status.bak > compiler\obj\win32\config.status
touch -m --reference=compiler\obj\win32\config.status.bak compiler\obj\win32\config.status

copy compiler\obj\win32\Makefile compiler\obj\win32\Makefile.bak
sed 's/\/g\/FreeBASIC\/src\/config\/missing //g' < compiler\obj\win32\Makefile.bak > compiler\obj\win32\Makefile
touch -m --reference=compiler\obj\win32\Makefile.bak compiler\obj\win32\Makefile

copy rtlib\obj\win32\config.status rtlib\obj\win32\config.status.bak
sed 's/\/g\/FreeBASIC\/src\/config\/missing //g' < rtlib\obj\win32\config.status.bak > rtlib\obj\win32\config.status
touch -m --reference=rtlib\obj\win32\config.status.bak rtlib\obj\win32\config.status

copy gfxlib2\obj\win32\config.status gfxlib2\obj\win32\config.status.bak
sed 's/\/g\/FreeBASIC\/src\/config\/missing //g' < gfxlib2\obj\win32\config.status.bak > gfxlib2\obj\win32\config.status
touch -m --reference=gfxlib2\obj\win32\config.status.bak gfxlib2\obj\win32\config.status

echo complete > g:\build\stat\strp_win.tmp

:WSTR04

REM ============================================================
REM configure rtlib, gfxlib2, and compiler for dos

IF EXIST g:\build\stat\conf_dos.tmp goto DCNF05

call setpath.bat FB181DOS

g:
cd \FreeBASIC\src

cd rtlib\obj\dos
sh ../../configure CFLAGS=-O2 CC=gcc --target=i386-pc-msdosdjgpp target_alias=i386-pc-msdosdjgpp
if errorlevel 1 goto ERROR
cd ..\..\..

cd gfxlib2\obj\dos
sh ../../configure CFLAGS=-O2 CC=gcc --target=i386-pc-msdosdjgpp target_alias=i386-pc-msdosdjgpp
if errorlevel 1 goto ERROR
cd ..\..\..

cd compiler\obj\dos
sh ../../configure CC=gcc --target=i386-pc-msdosdjgpp target_alias=i386-pc-msdosdjgpp --enable-standalone
if errorlevel 1 goto ERROR
cd ..\..\..

echo complete > g:\build\stat\conf_dos.tmp

:DCNF05

IF EXIST g:\build\stat\strp_dos.tmp goto DSTR06

call setpath.bat MINGW

g:
cd \FreeBASIC\src

copy compiler\obj\dos\config.status compiler\obj\dos\config.status.bak
sed 's/g:\/FreeBASIC\/src\/config\/missing //g' < compiler\obj\dos\config.status.bak > compiler\obj\dos\config.status
touch -m --reference=compiler\obj\dos\config.status.bak compiler\obj\dos\config.status

copy compiler\obj\dos\Makefile compiler\obj\dos\Makefile.bak
sed 's/g:\/FreeBASIC\/src\/config\/missing //g' < compiler\obj\dos\Makefile.bak > compiler\obj\dos\Makefile
touch -m --reference=compiler\obj\dos\Makefile.bak compiler\obj\dos\Makefile

copy rtlib\obj\dos\config.status rtlib\obj\dos\config.status.bak
sed 's/g:\/FreeBASIC\/src\/config\/missing //g' < rtlib\obj\dos\config.status.bak > rtlib\obj\dos\config.status
touch -m --reference=rtlib\obj\dos\config.status.bak rtlib\obj\dos\config.status

copy gfxlib2\obj\dos\config.status gfxlib2\obj\dos\config.status.bak
sed 's/g:\/FreeBASIC\/src\/config\/missing //g' < gfxlib2\obj\dos\config.status.bak > gfxlib2\obj\dos\config.status
touch -m --reference=gfxlib2\obj\dos\config.status.bak gfxlib2\obj\dos\config.status

echo complete > g:\build\stat\strp_dos.tmp

:DSTR06

REM ============================================================
REM merge in binaries from last distribution

IF EXIST g:\build\stat\mrgwin32.tmp goto MRG07

g:\build\merge.exe copy g:/freebasic.201 g:\FreeBASIC current win32
if errorlevel 1 goto ERROR

echo complete > g:\build\stat\mrgwin32.tmp

:MRG07

REM ============================================================
REM merge in binaries from last distribution

IF EXIST g:\build\stat\mrgdos32.tmp goto MRG08

g:\build\merge.exe copy g:/freebasic.201 g:\FreeBASIC current dos32
if errorlevel 1 goto ERROR

echo complete > g:\build\stat\mrgdos32.tmp

:MRG08

REM ============================================================
REM convert line endings CRLF to LF on some files

copy g:\build\crlf.bas g:\FreeBASIC\src
copy g:\build\crlf.exe g:\FreeBASIC\src
copy g:\build\crlf.lst g:\FreeBASIC\src

IF NOT EXIST g:\build\crlf.exe goto ERROR

g:
cd \FreeBASIC\src

g:\FreeBASIC\src\crlf.exe check
if errorlevel 1 goto ERROR

REM ============================================================
REM make rtlib, gfxlib2, and compiler for dos

IF EXIST g:\build\stat\make_dos.tmp goto MAKD09

call setpath.bat FB181DOS

g:
cd \FreeBASIC\src

cd rtlib\obj\dos
make
if errorlevel 1 goto ERROR

copy libfb.a ..\..\..\..\lib\dos\libfb.a
copy libfb.a ..\..\..\..\lib\dos\libfbmt.a
copy fbrt0.o ..\..\..\..\lib\dos
cd ..\..\..

cd gfxlib2\obj\dos
make
if errorlevel 1 goto ERROR
copy libfbgfx.a ..\..\..\..\lib\dos
cd ..\..\..

cd compiler\obj\dos
make FBC=fbc_dos.exe 
if errorlevel 1 goto ERROR

copy fbc_new.exe ..\..\..\..\fbc_dos.exe
copy fbc_new.exe fbc_dos_0.bak

cd ..\..\..

echo complete > g:\build\stat\make_dos.tmp

:MAKD09

REM ============================================================
REM make rtlib, gfxlib2, and compiler for windows

IF EXIST g:\build\stat\make_win.tmp goto MAKW10

call setpath.bat FB181

g:
cd \FreeBASIC\src

cd rtlib\obj\win32
make
if errorlevel 1 goto ERROR
make MULTITHREADED=1
if errorlevel 1 goto ERROR
copy libfb.a ..\..\..\..\lib\win32
copy libfbmt.a ..\..\..\..\lib\win32
copy fbrt0.o ..\..\..\..\lib\win32
cd ..\..\..

cd gfxlib2\obj\win32
make
if errorlevel 1 goto ERROR
copy libfbgfx.a ..\..\..\..\lib\win32
cd ..\..\..

cd compiler\obj\win32
make FBC=fbc_win.exe 
if errorlevel 1 goto ERROR

copy fbc_new.exe ..\..\..\..\fbc_win.exe
copy fbc_new.exe ..\..\..\..\fbc.exe
copy fbc_new.exe fbc_win_0.bak

echo complete > g:\build\stat\make_win.tmp

:MAKW10

REM ============================================================
REM remake compiler from last made compiler #1

IF EXIST g:\build\stat\rmk_dos1.tmp goto RMK11

call setpath.bat FBRELDOS

g:
cd \FreeBASIC\src\compiler\obj\dos

make mostlyclean
if errorlevel 1 goto ERROR
make FBC=../../../../fbc_dos.exe FB_BFD=1 BFD_VER=217
if errorlevel 1 goto ERROR
copy fbc_new.exe ..\..\..\..\fbc_dos.exe
copy fbc_new.exe ..\..\..\..\fbc.exe
copy fbc_new.exe fbc_dos_1.bak

cd ..\..\..

echo complete > g:\build\stat\rmk_dos1.tmp

:RMK11

REM ============================================================
REM remake compiler from last made compiler #2

IF EXIST g:\build\stat\rmk_dos2.tmp goto RMK12

call setpath.bat FBRELDOS

g:
cd \FreeBASIC\src\compiler\obj\dos

make mostlyclean
if errorlevel 1 goto ERROR
make FBC=../../../../fbc_dos.exe FB_BFD=1 BFD_VER=217
if errorlevel 1 goto ERROR
copy fbc_new.exe ..\..\..\..\fbc_dos.exe
copy fbc_new.exe ..\..\..\..\fbc.exe
copy fbc_new.exe fbc_dos_2.bak

cd ..\..\..

echo complete > g:\build\stat\rmk_dos2.tmp

:RMK12

REM ============================================================
REM remake compiler from last made compiler #1

IF EXIST g:\build\stat\rmk_win1.tmp goto RMK13

call setpath.bat FBREL

g:
cd \FreeBASIC\src\compiler\obj\win32

make mostlyclean
if errorlevel 1 goto ERROR
make FBC=../../../../fbc_win.exe FB_BFD=1 BFD_VER=217
if errorlevel 1 goto ERROR
copy fbc_new.exe ..\..\..\..\fbc_win.exe
copy fbc_new.exe ..\..\..\..\fbc.exe
copy fbc_new.exe fbc_win_1.bak

cd ..\..\..

echo complete > g:\build\stat\rmk_win1.tmp

:RMK13

REM ============================================================
REM remake compiler from last made compiler #2

IF EXIST g:\build\stat\rmk_win2.tmp goto RMK14

call setpath.bat FBREL

g:
cd \FreeBASIC\src\compiler\obj\win32

make mostlyclean
if errorlevel 1 goto ERROR
make FBC=../../../../fbc_win.exe FB_BFD=1 BFD_VER=217
if errorlevel 1 goto ERROR
copy fbc_new.exe ..\..\..\..\fbc_win.exe
copy fbc_new.exe ..\..\..\..\fbc.exe
copy fbc_new.exe fbc_win_2.bak

cd ..\..\..

echo complete > g:\build\stat\rmk_win2.tmp

:RMK14

REM ============================================================
REM compare the last two compilers

IF EXIST g:\build\stat\diffdos.tmp goto DIF15

g:
cd \FreeBASIC\src\compiler\obj\dos

g:\build\diffexe.exe fbc_dos_1.bak fbc_dos_2.bak 0
if errorlevel 1 goto ERROR

cd ..\..\..

echo complete > g:\build\stat\diffdos.tmp

:DIF15

REM ============================================================
REM compare the last two compilers

IF EXIST g:\build\stat\diffwin.tmp goto DIF16

g:
cd \FreeBASIC\src\compiler\obj\win32

g:\build\diffexe.exe fbc_win_1.bak fbc_win_2.bak 256
if errorlevel 1 goto ERROR

cd ..\..\..

echo complete > g:\build\stat\diffwin.tmp

:DIF16

REM ============================================================
REM do the test suite for WIN

call setpath.bat FBREL

IF EXIST g:\build\stat\testsuiw.tmp goto TSTW17

g:
cd \FreeBASIC\tests

make cunit-tests FBC=g:/FreeBASIC/fbc_win.exe
if errorlevel 1 goto ERROR
make clean
if errorlevel 1 goto ERROR

cd ..

echo complete > g:\build\stat\testsuiw.tmp

:TSTW17

REM ============================================================
REM do the test suite for DOS

call setpath.bat FBRELDOS

IF EXIST g:\build\stat\testsuid.tmp goto TSTD18

g:
cd \FreeBASIC\tests

make cunit-tests FBC=g:/FreeBASIC/fbc_dos.exe OS=DOS
if errorlevel 1 goto ERROR
make clean OS=DOS
if errorlevel 1 goto ERROR

cd ..

echo complete > g:\build\stat\testsuid.tmp

:TSTD18

REM ============================================================
REM build all the samples for win

IF EXIST g:\build\stat\testsmpw.tmp goto SMPW19

call setpath.bat FBREL

g:
cd \FreeBASIC\examples\manual

..\..\fbc_win.exe samples.bas
if errorlevel 1 goto ERROR
samples.exe compile -error -fbc ../../fbc_win.exe
if errorlevel 1 goto ERROR
samples clean
if errorlevel 1 goto ERROR

cd ..\..

echo complete > g:\build\stat\testsmpw.tmp

:SMPW19

REM ============================================================
REM build all the samples for dos

IF EXIST g:\build\stat\testsmpd.tmp goto SMPD20

call setpath.bat FBRELDOS

g:
cd \FreeBASIC\examples\manual

..\..\fbc_dos.exe samples.bas
if errorlevel 1 goto ERROR
samples.exe compile -error -fbc ../../fbc_dos.exe
if errorlevel 1 goto ERROR
samples clean
if errorlevel 1 goto ERROR

cd ..\..

echo complete > g:\build\stat\testsmpd.tmp

:SMPD20

REM ============================================================
REM build all examples for win

IF EXIST g:\build\stat\testexaw.tmp goto EXAW21

call setpath.bat FBREL

g:
cd \FreeBASIC\examples

make FBC=g:/FreeBASIC/fbc_win.exe
if errorlevel 1 goto ERROR
make clean
if errorlevel 1 goto ERROR

cd ..

echo complete > g:\build\stat\testexaw.tmp

:EXAW21

REM ============================================================
REM build the windows installer exe

IF EXIST g:\build\stat\wininst.tmp goto INST22

call setpath.bat FBREL

g:
cd \FreeBASIC\src\contrib\w32_inst

mkdir g:\temp
mkdir g:\tmpinst

set TMP=g:\temp
set TEMP=g:\temp

make FBC=g:/freebasic/fbc_win.exe MAKENSIS="f:/NSIS/makensis.exe" $INSTDIR=g:/tmpinst
if errorlevel 1 goto ERROR
make Setup.exe MAKENSIS="f:/NSIS/makensis.exe" $INSTDIR=g:/tmpinst
if errorlevel 1 goto ERROR

echo complete > g:\build\stat\wininst.tmp

:INST22

REM ============================================================
REM ALL DONE

copy g:\build\mkdist.bat g:\FreeBASIC
if errorlevel 1 goto ERROR

g:
cd \FreeBASIC

echo complete > g:\build\stat\all_done.tmp
goto END

REM ============================================================
REM Error handler
:ERROR
@echo ==============================================
@echo ===============     BUILD ERROR    ===========
@echo ==============================================
goto END


REM ============================================================
REM END
:END

