@echo off
if "%1" == "" goto HELP
if "%2" == "" goto HELP
if "%3" == "" goto HELP

set DRV=g:
set SRC=FreeBASIC

set mft=manifest\%1
set dst=h:\upload\fbc\dist\%2
set vers=%3

mkdir %dst%
del %dst%\*.zip
del %dst%\*.gz

echo manifest : %1
echo date     : %2
echo version  : %vers%

%DRV%
cd \%SRC%

cd manifest
g:\build\merge.exe dist FreeBASIC g:/FreeBASIC %1 win32
g:\build\merge.exe dist FreeBASIC g:/FreeBASIC %1 dos32
cd ..

cd src
REM crlf dos
cd ..

copy fbc.exe fbc.bak

copy fbc_dos.exe fbc.exe
cd ..
wzzip -ex -P -o @FreeBASIC\%mft%\dist-dos32.lst        %dst%\FreeBASIC-%vers%-dos32.zip
cd FreeBASIC

copy fbc_win.exe fbc.exe
cd ..
wzzip -ex -P -o @FreeBASIC\%mft%\dist-win32.lst        %dst%\FreeBASIC-%vers%-win32.zip
cd FreeBASIC

copy fbc.bak fbc.exe

goto NOLINUX
cd ..
REM wzzip -ex -P -o @FreeBASIC\%mft%\dist-linux.lst        %dst%\FreeBASIC-%vers%-linux.zip
cd FreeBASIC

cd src
REM crlf linux
cd ..

cd ..
tar -czf /h/upload/fbc/dist/%2/FreeBASIC-%vers%-linux.tar.gz -T FreeBASIC\%mft%\dist-linux.lst --owner=coder --group=coder
cd FreeBASIC

:NOLINUX

wzzip -ex -P -o @%mft%\compiler_src.lst %dst%\fbc-%vers%-src.zip
wzzip -ex -P -o @%mft%\rtlib_src.lst @%mft%\gfxlib2_src.lst  %dst%\libfb-%vers%-src.zip
REM wzzip -ex -P -o @%mft%\gfxlib2_src.lst  %dst%\libfbgfx-%vers%-src.zip
REM wzzip -ex -P -o @%mft%\rtlib_src.lst    %dst%\libfb-%vers%-src.zip

wzzip -ex -P -o @%mft%\tests.lst %dst%\fbc-%vers%-tests.zip

cd ..

:TEMP1
copy g:\freebasic\src\contrib\w32_inst\FreeBASIC-vX.XXb-win32.exe %dst%\FreeBASIC-%vers%-win32.exe


goto END
:HELP
echo mkdist manifest yyyy.mm.dd [version]
echo version has format v#.#b
:END

set dst=
set mft=
set vers=
